import _extends from 'babel-runtime/helpers/extends';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { findDOMNode } from 'react-dom';
import invariant from 'invariant';
import { removeItem } from './utils';

import { provideDisplayName, omit } from '../utils';
// Export Higher Order Sortable Element Component
export default function sortableElement(WrappedComponent) {
  var _class, _temp2;

  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { withRef: false };

  return _temp2 = _class = function (_Component) {
    _inherits(_class, _Component);

    function _class() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, _class);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class.__proto__ || _Object$getPrototypeOf(_class)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
        selected: false
      }, _this.onSelect = function (e) {
        var manager = _this.context.manager;
        var dragLayer = manager.dragLayer;
        var selectedItemsOnDragLayer = dragLayer.selectedItems;
        if (!(e.metaKey || e.ctrlKey)) {
          dragLayer.unselectAll();
          dragLayer.removeAllSelectedFromManagers();
        }
        if (_this.props.isAlwaysSelected) {
          return;
        }
        if (!_this.state.selected) {
          manager.selected.push(_this.node.sortableInfo.index);
          selectedItemsOnDragLayer.push(_this);
        } else {
          _this.removeSelectedFromManager();
          _this.removeSelectedFromDraglayer();
        }
        _this.setState({
          selected: !_this.state.selected
        });
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(_class, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _props = this.props,
            collection = _props.collection,
            disabled = _props.disabled,
            index = _props.index,
            isAlwaysSelected = _props.isAlwaysSelected;

        if (isAlwaysSelected) {
          this.context.manager.alwaysSelected.push(index);
        }
        if (!disabled) {
          this.setDraggable(collection, index);
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (this.props.index !== nextProps.index && this.node) {
          this.node.sortableInfo.index = nextProps.index;
        }
        if (this.props.disabled !== nextProps.disabled) {
          var collection = nextProps.collection,
              disabled = nextProps.disabled,
              index = nextProps.index;

          if (disabled) {
            this.removeDraggable(collection);
          } else {
            this.setDraggable(collection, index);
          }
        } else if (this.props.collection !== nextProps.collection || nextProps.item && nextProps.item.selectedItems) {
          this.removeDraggable(this.props.collection);
          this.setDraggable(nextProps.collection, nextProps.index);
        }
        this.setState({
          selected: nextProps.isAlwaysSelected
        });
        if (this.props.isAlwaysSelected !== nextProps.isAlwaysSelected) {
          var isAlwaysSelected = nextProps.isAlwaysSelected,
              _index = nextProps.index;
          var alwaysSelected = this.context.manager.alwaysSelected;

          if (isAlwaysSelected) {
            alwaysSelected.push(_index);
          } else {
            removeItem(alwaysSelected, _index);
          }
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var _props2 = this.props,
            collection = _props2.collection,
            disabled = _props2.disabled,
            isAlwaysSelected = _props2.isAlwaysSelected,
            index = _props2.index;

        if (isAlwaysSelected) {
          removeItem(this.context.manager.alwaysSelected, index);
        }
        this.removeSelectedFromDraglayer();
        if (!disabled) this.removeDraggable(collection);
      }
    }, {
      key: 'setDraggable',
      value: function setDraggable(collection, index) {
        var node = this.node = findDOMNode(this);

        node.sortableInfo = {
          index: index,
          collection: collection,
          manager: this.context.manager
        };

        this.ref = { node: node };
        this.context.manager.add(collection, this.ref);
      }
    }, {
      key: 'removeDraggable',
      value: function removeDraggable(collection) {
        this.context.manager.remove(collection, this.ref);
      }
    }, {
      key: 'getWrappedInstance',
      value: function getWrappedInstance() {
        invariant(config.withRef, 'To access the wrapped instance, you need to pass in {withRef: true} as the second argument of the SortableElement() call');
        return this.refs.wrappedInstance;
      }
    }, {
      key: 'unselect',
      value: function unselect() {
        this.setState({
          selected: false
        });
      }
    }, {
      key: 'removeSelectedFromDraglayer',
      value: function removeSelectedFromDraglayer() {
        removeItem(this.context.manager.dragLayer.selectedItems, this);
      }
    }, {
      key: 'removeSelectedFromManager',
      value: function removeSelectedFromManager() {
        removeItem(this.context.manager.selected, this.node.sortableInfo);
      }
    }, {
      key: 'render',
      value: function render() {
        var _context$manager = this.context.manager,
            helperClass = _context$manager.helperClass,
            selectedClass = _context$manager.selectedClass,
            isMultiple = _context$manager.isMultiple;

        var ref = config.withRef ? 'wrappedInstance' : null;
        var props = _extends({}, omit(this.props, 'collection', 'disabled', 'index'));
        var selectedItems = this.props.selectedItems;

        if (selectedItems) {
          return React.createElement(
            'div',
            null,
            selectedItems.map(function (value, index) {
              return React.createElement(
                'div',
                {
                  key: index,
                  className: helperClass
                },
                React.createElement(WrappedComponent, _extends({
                  key: index
                }, value, props))
              );
            })
          );
        }
        var component = React.createElement(WrappedComponent, _extends({
          ref: ref
        }, props));
        if (isMultiple) {
          return React.createElement(
            'div',
            {
              onClick: this.onSelect,
              className: this.state.selected ? selectedClass : ''
            },
            component
          );
        }
        return component;
      }
    }]);

    return _class;
  }(Component), _class.displayName = provideDisplayName('sortableElement', WrappedComponent), _class.contextTypes = {
    manager: PropTypes.object.isRequired
  }, _class.propTypes = {
    index: PropTypes.number.isRequired,
    collection: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
    disabled: PropTypes.bool
  }, _class.defaultProps = {
    collection: 0
  }, _temp2;
}